Menu

- Learn
- Documentation
  - Language Reference
  - Library Reference
  - Command-line Reference
  - Feature Overview
  - Articles
- Packages
- Community
  - Blog
  - Orgs using D
  - Twitter
  - Forums
  - IRC
  - Wiki
  - GitHub
  - Issues
  - Get involved
  - Foundation
  - Donate
- Resources
  - Books
  - Tutorials
  - Tools
  - Editors
  - IDEs
  - Visual D
  - Acknowledgments
  - D Style
  - Glossary
  - Sitemap

Search
Report a bug
If you spot a problem with this page, click here to create a Bugzilla issue.
Improve this page
Quickly fork, edit online, and submit a pull request for this page. Requires a signed-in GitHub account. This works well for small changes. If you'd like to make larger changes you may want to consider using a local clone.

# ddmd.mtype

Compiler implementation of the D programming language.
Authors:
Walter Bright
License:
Boost License 1.0

Source: mtype.d

pure nothrow @nogc @safe bool `MODimplicitConv`(MOD `modfrom`, MOD `modto`);
  Return !=0 if `modfrom` can be implicitly converted to `modto`
pure nothrow @nogc @safe MATCH `MODmethodConv`(MOD `modfrom`, MOD `modto`);
  Return MATCHexact or MATCHconst if a method of type '() `modfrom`' can call a method of type '() `modto`'.
pure nothrow @nogc @safe MOD `MODmerge`(MOD `mod1`, MOD `mod2`);
  Merge mod bits to form common mod.
void `MODtoBuffer`(OutBuffer* `buf`, MOD `mod`);
  Store modifier name into `buf`.
char* `MODtoChars`(MOD `mod`);
  Return modifier name.
pure nothrow @nogc @safe StorageClass `ModToStc`(uint `mod`);
  Convert MODxxxx to STCxxx
abstract class `Type`: ddmd.root.rootobject.RootObject;
  final int `covariant`(Type `t`, StorageClass* `pstc` = null, bool `fix17349` = true);
    Covariant means that 'this' can substitute for '`t`', i.e. a pure function is a match for an impure type.
    Parameters:

    Type `t` | type 'this' is `covariant` with
    StorageClass* `pstc` | if not `null`, store STCxxxx which would make it `covariant`
    bool `fix17349` | enable fix https://issues.dlang.org/show_bug.cgi?id=17349

    Returns:
    0 types are distinct 1 this is `covariant` with `t` 2 arguments match as far as overloading goes, but types are not `covariant` 3 cannot determine covariance because of forward references *`pstc` STCxxxx which would make it `covariant`
  final const(char)* `toChars`();
    For pretty-printing a type.
  final Type `merge`();
  final Type `merge2`();
    This version does a merge even if the deco is already computed. Necessary for types that have a deco, but are not merged.
  final void `modToBuffer`(OutBuffer* `buf`);
    Store this type's modifier name into `buf`.
  final char* `modToChars`();
    Return this type's modifier name.
  final int `modifiersApply`(void* `param`, int function(void*, const(char)*) `fp`);
    For each active modifier (MODconst, MODimmutable, etc) call `fp` with a void* for the work `param` and a string representation of the attribute.
  bool `isAssignable`();
    When T is mutable,

    Given: T a, b; Can we bitwise assign: a = b; ?

  bool `isBoolean`();
    Returns `true` if T can be converted to boolean value.
  void `checkDeprecated`(Loc `loc`, Scope* `sc`);
    Check type to see if it is based on a deprecated symbol.
  final Type `nullAttributes`();
    Return a copy of this type with all attributes `null`-initialized. Useful for creating a type with different modifiers.
  final Type `constOf`();
    Convert to 'const'.
  final Type `immutableOf`();
    Convert to 'immutable'.
  final Type `mutableOf`();
    Make type mutable.
  final Type `unSharedOf`();
    Make type unshared. 0 => 0 const => const immutable => immutable shared => 0 shared const => const wild => wild wild const => wild const shared wild => wild shared wild const => wild const
  final Type `wildOf`();
    Convert to 'wild'.
  final void `fixTo`(Type `t`);
    For our new type 'this', which is type-constructed from `t`, fill in the cto, ito, sto, scto, wto shortcuts.
  final void `check`();
    Look for bugs in constructing types.
  final Type `addSTC`(StorageClass `stc`);
    Apply STCxxxx bits to existing type. Use *before* semantic analysis is run.
  final Type `castMod`(MOD `mod`);
    Apply MODxxxx bits to existing type.
  final Type `addMod`(MOD `mod`);
    Add MODxxxx bits to existing type. We're adding, not replacing, so adding const to a shared type => "shared const"
  Type `addStorageClass`(StorageClass `stc`);
    Add storage class modifiers to type.
  Type `toBasetype`();
    If this is a shell around another type, get that other type.
  MATCH `implicitConvTo`(Type `to`);
    Determine if 'this' can be implicitly converted `to` type '`to`'.
    Returns:
    MATCHnomatch, MATCHconvert, MATCHconst, MATCHexact
  MATCH `constConv`(Type `to`);
    Determine if converting 'this' `to` '`to`' is an identity operation, a conversion `to` const operation, or the types aren't the same.
    Returns:
    MATCHexact 'this' == '`to`' MATCHconst '`to`' is const MATCHnomatch conversion `to` mutable or invariant
  ubyte `deduceWild`(Type `t`, bool `isRef`);
    Return MOD bits matching this type to wild parameter type (tprm).
  Type `toHeadMutable`();
    Return type with the top level of it being mutable.
  Expression `getProperty`(Loc `loc`, Identifier `ident`, int `flag`);
    Calculate built-in properties which just the type is necessary.
    If `flag` & 1, don't report "not a property" error and just return NULL.
  enum `DotExpFlag`: int;
    dotExp() bit flags
  Expression `dotExp`(Scope* `sc`, Expression `e`, Identifier `ident`, int `flag`);
    Access the members of the object `e`. This type is same as `e`.type.
    Parameters:

    int `flag` | DotExpFlag bit flags

    Returns:
    resulting expression with `e`.`ident` resolved
  structalign_t `alignment`();
    Return `alignment` to use for this type.
  final Expression `noMember`(Scope* `sc`, Expression `e`, Identifier `ident`, int `flag`);
    Figures out what to do with an undefined member reference for classes and structs.
    If `flag` & 1, don't report "not a property" error and just return NULL.
  Expression `defaultInitLiteral`(Loc `loc`);
    Use when we prefer the default initializer to be a literal, rather than a global immutable variable.
  void `resolve`(Loc `loc`, Scope* `sc`, Expression* `pe`, Type* `pt`, Dsymbol* `ps`, bool `intypeid` = false);
    Resolve 'this' type to either type, symbol, or expression. If errors happened, resolved to Type.terror.
  final void `resolveExp`(Expression `e`, Type* `pt`, Expression* `pe`, Dsymbol* `ps`);
    Normalize `e` as the result of Type.resolve() process.
  const int `hasWild`();
    Return !=0 if the type or any of its subtypes is wild.
  bool `hasPointers`();
    Return !=0 if type has pointers that need to be scanned by the GC during a collection cycle.
  bool `hasVoidInitPointers`();
    Detect if type has pointer fields that are initialized to void. Local stack variables with such void fields can remain uninitialized, leading to pointer bugs.
    Returns:
    `true` if so
  Type `nextOf`();
    If this is a type of something, return that something.
  final Type `baseElemOf`();
    If this is a type of static array, return its base element type.
  final uinteger_t `sizemask`();
    Return the mask that an integral type will fit into.
  bool `needsDestruction`();
    `true` if when type goes out of scope, it needs a destructor applied. Only applies to value types, not ref types.
  bool `needsNested`();
  final void `checkComplexTransition`(Loc `loc`);

    https: //issues.dlang.org/show_bug.cgi?id=14488 Check if the inner most base type is complex or imaginary. Should only give alerts when set to emit transitional messages.

class `TypeError`: ddmd.mtype.Type;
abstract class `TypeNext`: ddmd.mtype.Type;
  final Type `nextOf`();
    For TypeFunction, `nextOf`() can return NULL if the function return type is meant to be inferred, and semantic() hasn't yet ben run on the function. After semantic(), it must no longer be NULL.
class `TypeBasic`: ddmd.mtype.Type;
class `TypeVector`: ddmd.mtype.Type;
  The basetype must be one of: byte[16],ubyte[16],short[8],ushort[8],int[4],uint[4],long[2],ulong[2],float[4],double[2] For AVX: byte[32],ubyte[32],short[16],ushort[16],int[8],uint[8],long[4],ulong[4],float[8],double[4]
class `TypeArray`: ddmd.mtype.TypeNext;
class `TypeSArray`: ddmd.mtype.TypeArray;
  Static array, one with a fixed dimension
  bool `needsNested`();
class `TypeDArray`: ddmd.mtype.TypeArray;
  Dynamic array, no dimension
class `TypeAArray`: ddmd.mtype.TypeArray;
class `TypePointer`: ddmd.mtype.TypeNext;
class `TypeReference`: ddmd.mtype.TypeNext;
class `TypeFunction`: ddmd.mtype.TypeNext;
  void `purityLevel`();
    Set 'purity' field of 'this'. Do this lazily, as the parameter types might be forward referenced.
  bool `hasLazyParameters`();
    Return `true` if there are lazy parameters.
  bool `parameterEscapes`(Parameter `p`);
    Examine function signature for parameter `p` and see if the value of `p` can 'escape' the scope of the function. This is useful to minimize the needed annotations for the parameters.
    Parameters:

    Parameter `p` | parameter to this function

    Returns:
    `true` if escapes via assignment to global or through a parameter
  final StorageClass `parameterStorageClass`(Parameter `p`);
    Take the specified storage class for `p`, and use the function signature to infer whether STCscope and STCreturn should be OR'd in. (This will not affect the name mangling.)
    Parameters:

    Parameter `p` | one of the parameters to 'this'

    Returns:
    storage class with STCscope or STCreturn OR'd in
  int `attributesApply`(void* `param`, int function(void*, const(char)*) `fp`, TRUSTformat `trustFormat` = TRUSTformatDefault);
    For each active attribute (ref/const/nogc/etc) call `fp` with a void* for the work `param` and a string representation of the attribute.
  MATCH `callMatch`(Type `tthis`, Expressions* `args`, int `flag` = 0);
    '`args`' are being matched to function 'this' Determine match level.

    Input: `flag` 1 performing a partial ordering match

    Returns:
    MATCHxxxx
class `TypeDelegate`: ddmd.mtype.TypeNext;
abstract class `TypeQualified`: ddmd.mtype.Type;
  final void `resolveTupleIndex`(Loc `loc`, Scope* `sc`, Dsymbol `s`, Expression* `pe`, Type* `pt`, Dsymbol* `ps`, RootObject `oindex`);
    Resolve a tuple index.
  final void `resolveHelper`(Loc `loc`, Scope* `sc`, Dsymbol `s`, Dsymbol `scopesym`, Expression* `pe`, Type* `pt`, Dsymbol* `ps`, bool `intypeid` = false);
    Takes an array of Identifiers and figures out if it represents a Type or an Expression.

    Output: if expression, *`pe` is set if type, *`pt` is set

class `TypeIdentifier`: ddmd.mtype.TypeQualified;
  void `resolve`(Loc `loc`, Scope* `sc`, Expression* `pe`, Type* `pt`, Dsymbol* `ps`, bool `intypeid` = false);
    Takes an array of Identifiers and figures out if it represents a Type or an Expression.

    Output: if expression, *`pe` is set if type, *`pt` is set

  Dsymbol `toDsymbol`(Scope* `sc`);
    See if type resolves to a symbol, if so, return that symbol.
class `TypeInstance`: ddmd.mtype.TypeQualified;
  Similar to TypeIdentifier, but with a TemplateInstance as the root
class `TypeTypeof`: ddmd.mtype.TypeQualified;
class `TypeReturn`: ddmd.mtype.TypeQualified;
class `TypeStruct`: ddmd.mtype.Type;
  Expression `defaultInitLiteral`(Loc `loc`);
    Use when we prefer the default initializer to be a literal, rather than a global immutable variable.
class `TypeEnum`: ddmd.mtype.Type;
class `TypeClass`: ddmd.mtype.Type;
class `TypeTuple`: ddmd.mtype.Type;
  this(Expressions* `exps`);
    Form TypeTuple from the types of the expressions. Assume `exps`[] is already tuple expanded.
  this();
    Type tuple with 0, 1 or 2 types in it.
class `TypeSlice`: ddmd.mtype.TypeNext;
  This is so we can slice a TypeTuple
class `TypeNull`: ddmd.mtype.Type;
class `Parameter`: ddmd.root.rootobject.RootObject;
  Type `isLazyArray`();
    Determine if parameter is a lazy array of delegates. If so, return the return type of those delegates. If not, return NULL.
    Returns T if the type is one of the following forms: T delegate()[] T delegate()[dim]
  static int `isTPL`(Parameters* `parameters`);
    Determine if parameter list is really a template parameter list (i.e. it has auto or alias `parameters`)
  static size_t `dim`(Parameters* `parameters`);
    Determine number of arguments, folding in tuples.
  static Parameter `getNth`(Parameters* `parameters`, size_t `nth`, size_t* `pn` = null);
    Get `nth` Parameter, folding in tuples.
    Returns:
    Parameter* `nth` Parameter NULL not found, *`pn` gets incremented by the number of Parameters
  static int `_foreach`(Parameters* `parameters`, scope ForeachDg `dg`, size_t* `pn` = null);
    Expands tuples in args in depth first order. Calls `dg`(void *ctx, size_t argidx, Parameter *arg) for each Parameter. If `dg` returns !=0, stops and returns that value else returns 0. Use this function to avoid the O(N + N^2/2) complexity of calculating dim and calling N times getNth.
  final const pure nothrow @nogc @safe bool `isCovariant`(bool `returnByRef`, const Parameter `p`);
    Compute covariance of parameters this and `p` as determined by the storage classes of both.
    Parameters:

    Parameter `p` | Parameter to compare with

    Returns:
    `true` = this can be used in place of `p` `false` = nope

Copyright © 1999-2017 by the D Language Foundation | Page generated by Ddoc on Fri Sep 1 12:52:39 2017